"""
TODO: Experiment with more sophisticated comparisons beyond number of players
"""
import json
import statistics

import click


def get_differences(summary_a, summary_b):
    """
    Given two summary dictionaries, compute their differences
    """
    differences = []
    for fixture_key in summary_a:
        num_players_a = summary_a[fixture_key]['num_players']
        num_players_b = summary_b[fixture_key]['num_players']
        difference = num_players_b - num_players_a
        # formatted row of output containing players used
        output_row = '{:40}{:>4} ➥{:>4}'.format(fixture_key,
                                                num_players_a,
                                                num_players_b)
        difference_row = [difference, output_row]
        differences.append(difference_row)
    return differences


def get_number_color(num):
    """
    Return color for positive or negative values
    """
    if num < 0:
        return 'red'
    elif num > 0:
        return 'green'
    return None


def print_differences(sorted_differences):
    """
    Print colorized version of output from get_differences
    """

    # style label text for output
    def get_style(label): return click.style(label, bold=True, fg='blue')

    click.echo(get_style('\nPlayers Used:'))
    click.echo('-------------------------')
    for diff_row in sorted_differences:
        diff = diff_row[0]
        fg_color = get_number_color(diff)
        click.echo(diff_row[1], nl=False)
        formatted_diff = '{:+5d}'.format(diff_row[0])
        click.echo(click.style(formatted_diff, fg=fg_color))

    diffs = [diff_row[0] for diff_row in sorted_differences]

    avg_diff = statistics.mean(diffs)
    median_diff = statistics.median(diffs)
    mode_diff = statistics.mode(diffs)

    diff_format = '{:>+15.2f}'

    # display summary of players used per build in each lineup
    click.echo(get_style('\nMean Difference Players Per Build:\t'), nl=False)
    click.echo(click.style(diff_format.format(avg_diff),
                           fg=get_number_color(avg_diff)))

    click.echo(get_style('Median Difference Players Per Build:\t'), nl=False)
    click.echo(click.style(diff_format.format(median_diff),
                           fg=get_number_color(median_diff)))

    click.echo(get_style('Mode Difference Players Per Build:\t'), nl=False)
    click.echo(click.style(diff_format.format(mode_diff),
                           fg=get_number_color(mode_diff)))


@click.command()
@click.argument('first_summary')
@click.argument('second_summary')
def compare_summaries(first_summary, second_summary):
    """
    Compare two algorithm summary json files generated by summarize_builds.py

    Assumes that both summary files were generated by running the same input
    fixtures through LineupBuilder using different LineupBuilder algorithms
    """
    summary_a = {}
    summary_b = {}
    # load summary files into dictionaries, keyed by fixture name
    with open(first_summary) as first_jsonfile:
        summary_a = json.load(first_jsonfile)
    with open(second_summary) as second_jsonfile:
        summary_b = json.load(second_jsonfile)

    # create formatted differences list
    differences = get_differences(summary_a, summary_b)
    # sort by difference
    sorted_differences = sorted(differences, key=lambda tup: tup[0])
    # display fixture differences
    print_differences(sorted_differences)


if __name__ == '__main__':
    compare_summaries()
